<template>
  <header>
    <h1 class="sr-only">Dark Theme</h1>
    <div
      class="flex items-center pl-3.5 pr-3.5 py-[0.569rem] border-b4 bg-background3"
    >
      <div class="w-1/2 logo" v-if="!logo.IsHidden">
        <nuxt-link :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'">
          <figure class="w-[59%] h-auto">
            <img :src="logo.ImagePath" alt="Dark Theme" />
          </figure>
        </nuxt-link>
      </div>
      <div class="flex justify-end items-center w-1/2 gap-3 mr-2" v-if="isd9betUnauth">
        <button @click="toggleAuthModal('login')" class="btn bg-secondary">
          <span class="text-base font-bold leading-4">{{
            $t("capital_login")
          }}</span>
        </button>
        <button @click="toggleAuthModal('register')" class="btn bg-primary">
          <span class="text-base font-bold leading-4">{{ $t("joinnow") }}</span>
        </button>
      </div>
      <div class="flex justify-end w-1/2 mr-[23px]" v-else>
        <utils-balance-information v-if="auth" :isSuspended="false" />
        <new-black-theme-hamburger-menu />
      </div>
    </div>
    <div
      class="py-2 bg-background2 h-[32px] w-full overflow-hidden"
      v-if="includeAnnouncement && !announcement.IsHidden"
    >
      <div class="container flex items-center h-full mx-auto">
        <utils-announcement :announcement="announcement.Text" />
      </div>
    </div>
  </header>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { useRoute } from "vue-router";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

const shownRoute = [
  "HomeInitial",
  "SportInitial",
  "VirtualSportInitial",
  "LiveCasinoInitial",
  "GameInitial",
  "GameEntryInitial",
  "KenoInitial",
  "PokerInitial",
  "CockfightInitial",
  "LotteryInitial",
  "PromotionInitial",
];

export default defineComponent({
  name: "MHeader1",
  props: {
    auth: {
      type: Boolean,
      default: false,
    },
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    includeAnnouncement: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  setup(props) {
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          props.themeProperties,
          "logo"
        )
    );
    const route = useRoute();
    const { name } = toRefs(route);
    const isHeaderShow = computed(() =>
      shownRoute.includes(name.value as string)
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          store.state.companyThemePropertiesFromApi.ThemeProperties,
          "announcement"
        )
    );
    const { getAssetImage } = commonHelper;
    const isd9betUnauth = computed(
      () => store.state.selectedThemeName.includes("black") && !store.state.auth
    );
    const toggleAuthModal = (option: "login" | "register"): void => {
      if (option === "login") {
        store.commit("updateLoginDialog", !store.state.showLoginDialog);
      }
      if (option === "register") {
        store.commit("updateRegisterDialog", !store.state.showRegisterDialog);
      }
    };
    return {
      logo,
      isHeaderShow,
      getAssetImage,
      toggleAuthModal,
      isd9betUnauth,
      announcement,
    };
  },
});
</script>
<style scoped>
.btn {
  @apply inline-block text-center rounded-2xl transition-colors duration-300;
  padding: 0.18rem 0 !important;
  width: 90px;
  min-width: 90px;
}
</style>
